
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Import_jobsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const import_jobs = await db.import_jobs.create(
            {
                id: data.id || undefined,
        
        status: data.status
        ||
        null
            ,
            
        started_at: data.started_at
        ||
        null
            ,
            
        finished_at: data.finished_at
        ||
        null
            ,
            
        total_rows: data.total_rows
        ||
        null
            ,
            
        valid_rows: data.valid_rows
        ||
        null
            ,
            
        invalid_rows: data.invalid_rows
        ||
        null
            ,
            
        warning_rows: data.warning_rows
        ||
        null
            ,
            
        job_name: data.job_name
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await import_jobs.setTenant( data.tenant || null, {
            transaction,
        });
        
        await import_jobs.setRequested_by( data.requested_by || null, {
            transaction,
        });
        
        await import_jobs.setData_entity( data.data_entity || null, {
            transaction,
        });
        
        await import_jobs.setFile_upload( data.file_upload || null, {
            transaction,
        });
        
        await import_jobs.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.import_jobs.getTableName(),
                belongsToColumn: 'error_report_file',
                belongsToId: import_jobs.id,
            },
            data.error_report_file,
            options,
        );
        

        return import_jobs;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const import_jobsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                status: item.status
            ||
            null
            ,
            
                started_at: item.started_at
            ||
            null
            ,
            
                finished_at: item.finished_at
            ||
            null
            ,
            
                total_rows: item.total_rows
            ||
            null
            ,
            
                valid_rows: item.valid_rows
            ||
            null
            ,
            
                invalid_rows: item.invalid_rows
            ||
            null
            ,
            
                warning_rows: item.warning_rows
            ||
            null
            ,
            
                job_name: item.job_name
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const import_jobs = await db.import_jobs.bulkCreate(import_jobsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < import_jobs.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.import_jobs.getTableName(),
                    belongsToColumn: 'error_report_file',
                    belongsToId: import_jobs[i].id,
                },
                data[i].error_report_file,
                options,
            );
        }
        

        return import_jobs;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const import_jobs = await db.import_jobs.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.started_at !== undefined) updatePayload.started_at = data.started_at;
        
        
        if (data.finished_at !== undefined) updatePayload.finished_at = data.finished_at;
        
        
        if (data.total_rows !== undefined) updatePayload.total_rows = data.total_rows;
        
        
        if (data.valid_rows !== undefined) updatePayload.valid_rows = data.valid_rows;
        
        
        if (data.invalid_rows !== undefined) updatePayload.invalid_rows = data.invalid_rows;
        
        
        if (data.warning_rows !== undefined) updatePayload.warning_rows = data.warning_rows;
        
        
        if (data.job_name !== undefined) updatePayload.job_name = data.job_name;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await import_jobs.update(updatePayload, {transaction});

        
        
        if (data.tenant !== undefined) {
            await import_jobs.setTenant(
              
              data.tenant,
              
              { transaction }
            );
        }
        
        if (data.requested_by !== undefined) {
            await import_jobs.setRequested_by(
              
              data.requested_by,
              
              { transaction }
            );
        }
        
        if (data.data_entity !== undefined) {
            await import_jobs.setData_entity(
              
              data.data_entity,
              
              { transaction }
            );
        }
        
        if (data.file_upload !== undefined) {
            await import_jobs.setFile_upload(
              
              data.file_upload,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await import_jobs.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.import_jobs.getTableName(),
                belongsToColumn: 'error_report_file',
                belongsToId: import_jobs.id,
            },
            data.error_report_file,
            options,
        );
        

        return import_jobs;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const import_jobs = await db.import_jobs.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of import_jobs) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of import_jobs) {
                await record.destroy({transaction});
            }
        });


        return import_jobs;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const import_jobs = await db.import_jobs.findByPk(id, options);

        await import_jobs.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await import_jobs.destroy({
            transaction
        });

        return import_jobs;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const import_jobs = await db.import_jobs.findOne(
            { where },
            { transaction },
        );

        if (!import_jobs) {
            return import_jobs;
        }

        const output = import_jobs.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.import_row_results_import_job = await import_jobs.getImport_row_results_import_job({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        output.tenant = await import_jobs.getTenant({
            transaction
        });
        
        
        output.requested_by = await import_jobs.getRequested_by({
            transaction
        });
        
        
        output.data_entity = await import_jobs.getData_entity({
            transaction
        });
        
        
        output.file_upload = await import_jobs.getFile_upload({
            transaction
        });
        
        
        output.error_report_file = await import_jobs.getError_report_file({
            transaction
        });
        
        
        output.organizations = await import_jobs.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.tenants,
        as: 'tenant',
        
        where: filter.tenant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.tenant.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.tenant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'requested_by',
        
        where: filter.requested_by ? {
          [Op.or]: [
            { id: { [Op.in]: filter.requested_by.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.requested_by.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.data_entities,
        as: 'data_entity',
        
        where: filter.data_entity ? {
          [Op.or]: [
            { id: { [Op.in]: filter.data_entity.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.data_entity.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.file_uploads,
        as: 'file_upload',
        
        where: filter.file_upload ? {
          [Op.or]: [
            { id: { [Op.in]: filter.file_upload.split('|').map(term => Utils.uuid(term)) } },
            {
              original_filename: {
                [Op.or]: filter.file_upload.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



      {
        model: db.file,
        as: 'error_report_file',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.job_name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'import_jobs',
                        'job_name',
                        filter.job_name,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'import_jobs',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.started_atRange) {
                const [start, end] = filter.started_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    started_at: {
                    ...where.started_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    started_at: {
                    ...where.started_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.finished_atRange) {
                const [start, end] = filter.finished_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    finished_at: {
                    ...where.finished_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    finished_at: {
                    ...where.finished_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.total_rowsRange) {
                const [start, end] = filter.total_rowsRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    total_rows: {
                    ...where.total_rows,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    total_rows: {
                    ...where.total_rows,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.valid_rowsRange) {
                const [start, end] = filter.valid_rowsRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    valid_rows: {
                    ...where.valid_rows,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    valid_rows: {
                    ...where.valid_rows,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.invalid_rowsRange) {
                const [start, end] = filter.invalid_rowsRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    invalid_rows: {
                    ...where.invalid_rows,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    invalid_rows: {
                    ...where.invalid_rows,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.warning_rowsRange) {
                const [start, end] = filter.warning_rowsRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    warning_rows: {
                    ...where.warning_rows,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    warning_rows: {
                    ...where.warning_rows,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.import_jobs.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'import_jobs',
                        'job_name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.import_jobs.findAll({
            attributes: [ 'id', 'job_name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['job_name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.job_name,
        }));
    }

    
};

